; structure of cmos
;
; To find fixed disk drive type information, look at locaton cm12.  The high
; nibble describes disk 1 and the low nibble describes disk 2.  If either
; nibble contains 'f' then look at locations 19h (disk 1) or location 1ah
; (disk 2) for drive type.  If either nibble is less than 'F' then it is
; the drive type.
;
; For PS/2 computers disk 1 type is stored at cm11 and disk 2 type at cm12.
; This information has not been verified accurate 100% of time.
;
; The bios uses cmos location cm12 on an AT to determine number of drives
; and type.  The PS/2 must use cmos locations cm11 & cm12 to find number
; of drives.
; IBM and most clones use the same method to determine number of drives
; and types, The cmos formats are identical.  Older IBM bios's only
; used location cm12 without extended drives, but new bios's allow the
; extended drive types stored at locations 19h & 1ah.
;
cmos	struc
 cm0	db	0	;0  seconds
 cm1	db	0	;1  seconds alarm
 cm2	db	0	;2  minutes
 cm3	db	0	;3  minutes alarm
 cm4	db	0	;4  hours
 cm5	db	0	;5  hours of alarm
 cm6	db	0	;6  day of week
 cm7	db	0	;7  day of month
 cm8	db	0	;8  month
 cm9	db	0	;9  year
 cm0a	db	0	;0a status a
 cm0b	db	0	;0b status b (alarm)
 cm0c	db	0	;0c status c (flags)
 cm0d	db	0	;0d status d (battery)
 cm0e	db	0	;0e post diag status results
 cm0f	db	0	;0f shutdown status
 cm10	db	0	;10 diskette drive type            checksumed
 cm11	db	0	;11 (PS/2 fixed disk 1 type)       checksumed
 cm12	db	0	;12 fixed disk type (PS/2 disk 2)  checksumed
 cm13	db	0	;13                                checksumed
 cm14	db	0	;14 equip word low byte            checksumed
 cm15	db	0	;15 low byte base memory size      checksumed
 cm16	db	0	;16 high byte base memory size     checksumed
 cm17	db	0	;17 low byte expansion memory      checksumed
 cm18	db	0	;18 high byte expansion memory     checksumed
 cm19	db	0	;19 fixed disk type "c"            checksumed
 cm1a	db	0	;1a fixed disk type "d"            checksumed
 cm1b	db	0       ;1b                                checksumed
 cm1c	db	0       ;1c                                checksumed
 cm1d	db	0       ;1d                                checksumed
 cm1e	db	0       ;1e                                checksumed
 cm1f	db	0       ;1f                                checksumed
 cm20	db	0       ;20                                checksumed
 cm21	db	0       ;21                                checksumed
 cm22	db	0       ;22                                checksumed
 cm23	db	0       ;23                                checksumed
 cm24	db	0       ;24                                checksumed
 cm25	db	0       ;25                                checksumed
 cm26	db	0       ;26                                checksumed
 cm27	db	0       ;27                                checksumed
 cm28	db	0       ;28                                checksumed
 cm29	db	0       ;29                                checksumed
 cm2a	db	0       ;2a                                checksumed
 cm2b	db	0       ;2b                                checksumed
 cm2c	db	0       ;2c                                checksumed
 cm2d	db	0       ;1d                                checksumed
 cm2e	db	0	;2e checksum high                  checksumed
 cm2f	db	0	;2f checksum low                   checksumed
 cm30	db	0	;30 usable mem above 1meg (low)
 cm31	db	0	;31 usable mem above 1meg (high)
 cm32	db	0	;32 century (bcd)
 cm33	db	0	;33 128k info. (status byte)
 cm34	db	0	;34 reserved
cmos	ends
